(*
  SXC: Compiler for a C-like language for the SX (Ubicom) microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>

  This code was almost entirely rewritten form an initial skeleton by Didier 
  Rmi, some of the original code probably remains.
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)

type ('o, 'i) t = { 
    move_to_top : 'o -> 'o -> bool; (* says if first element should move nearer to top *)
      index : 'o-> 'i; (* gives an index for an element *)
	hash : ('i, int) Hashtbl.t;
	mutable numelems : int;
	mutable heap : 'o option array 
  }
exception Collision
exception Empty
val empty : ('o, 'i) t -> bool
val create : ('o -> 'o -> bool) -> ('o -> 'i) -> int -> ('o, 'i) t
val head : ('o, 'i) t -> 'o
val add : ('o, 'i) t -> 'o -> unit
val remove : ('o, 'i) t -> 'o -> unit
val find : ('o, 'i) t -> 'i -> 'o
val collision : ('o, 'i) t -> 'o -> 'o option
val iter : ('o -> unit) -> ('o, 'i) t -> unit
(*val testheap : ('o, 'i) t -> unit*)
