/*
  SXC: Compiler for a C-like language for the SX (Ubicom) microcontroller.
  Copyright (C) 1999 Blaise Gassend <blaise at gassend dot com> 
  and Franois-Marie Lefevere <francois-marie dot lefevere at m4x dot org>

  This code was almost entirely rewritten form an initial skeleton by Didier 
  Rmi, some of the original code probably remains.
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

byte readRC()
{
  return RC;
}

void writeRB(byte val)
{
  RB = val;
}

byte sumofint(byte val)
{
  byte ret;
 
  for (ret = 0; val != 0; ret += val, val--);

  return ret;
}

byte fibb(byte val)
{
  byte a = 1, b = 1, c;
  
  for (; val > 0; val--)
  {
    c = a + b;
    a = b;
    b = c;
  }

  return a;
}

byte calc(byte val)
{
  return fibb(val); 
}

void main()
{
  M = 0x0F;
  !RB = 0;

  while (1)
  {
    writeRB(calc(readRC()));
  }
}
